package com.unitesk.requality.core.checkers;

import java.util.ArrayList;

import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.nodetypes.ErrorNode;

public class CheckerContainer {
    private ArrayList<IChecker> checkers = new ArrayList<IChecker>();
    private TreeNode curNode;
    public void check(TreeNode node) {
        doCheck(node);
    }

    protected void doCheck(TreeNode node) {
        curNode = node;
        ArrayList<CheckerProblem> result = new ArrayList<CheckerProblem>();
        if (node instanceof ErrorNode) {
            result.add(new CheckerProblem(node, "Corrupted element"));
        }
        for(IChecker checker: checkers) {
            CheckerProblem[] r = checker.check(node);
            for(CheckerProblem problem: r) {
                result.add(problem);
            }
        }
        applyProblemsInfo(result);
    }

    public TreeNode getNode() {
        return curNode;
    }

    protected void applyProblemsInfo(ArrayList<CheckerProblem> result) {
        for(CheckerProblem problem: result) {
            System.out.println(problem);
        }
    }

    public void addChecker(IChecker checker) {
        checkers.add(checker);
    }
}
