package com.unitesk.requality.marker;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.viewers.IDecoration;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ILightweightLabelDecorator;

import com.unitesk.requality.core.Attribute;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.Activator;
import com.unitesk.requality.nodetypes.TestPurpose;

public class TestPurposeDecorator implements ILightweightLabelDecorator {
    @Override
    public void addListener(ILabelProviderListener listener) {
    }

    @Override
    public void dispose() {
    }
    private void addOverlay(IDecoration decoration,String name,int pos){
        ImageDescriptor id = Activator.getImageDescriptor(
                "icons/overlays/" + name);
        decoration.addOverlay(id, pos);
    }
    @Override
    public void decorate(Object element, IDecoration decoration) {
        TreeNode node = (TreeNode) element;
        Attribute attr = node.getAttribute(TestPurpose.ATTR_STATUS);
        if(attr != null){
            addOverlay(decoration,"tp_" + ((String)attr.getValue())+".png",  IDecoration.TOP_LEFT);
        } else {
            addOverlay(decoration,"tp_in process.png",  IDecoration.TOP_LEFT);
        }
    }

    @Override
    public void removeListener(ILabelProviderListener listener) {
    }

    @Override
    public boolean isLabelProperty(Object element, String property) {
        return true;
    }

}
