package com.unitesk.requality.eclipse.handlers;

import java.util.List;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;

import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.editors.NodeEditorInput;
import com.unitesk.requality.eclipse.ui.cnf.RequalityCNF;
import com.unitesk.requality.eclipse.ui.editors.UniEditor;

public class OpenTestPurposeHandler extends AbstractHandler {
    @Override
    public Object execute(ExecutionEvent event) throws ExecutionException {
        List<TreeNode> tcs = RequalityCNF.getSelectedNodes();
        for(TreeNode tc : tcs){
            NodeEditorInput input = new NodeEditorInput(tc.getParent(), tc);
            try {
                PlatformUI.getWorkbench().getActiveWorkbenchWindow()
                        .getActivePage().openEditor(input, UniEditor.ID);
            } catch (PartInitException e) {
                e.printStackTrace();
            }
        }
        return null;
    }
}
